% This function implement the connectivity control term
function [term]=conn(x,A,vv,lam2, sigma, epsilon)

n=size(x,1);

deriv=zeros(n,2);


for i=1:n
    for j=1:n
        if A(i,j)>0
            % Compute the derivative term for the pair (i,j)
            der_ij=A(i,j)*(vv(i)-vv(j))^2*(x(i,:)-x(j,:))/sigma^2;
            % Update the overall control term
            deriv(i,:)=deriv(i,:)-der_ij;
        end
    end
end

% Final control term scaled by the adaptive gain
term=csch((lam2-epsilon)/5)^2*deriv;
    
      
