%Function to generate the initial robots conditions
function [x0,Adj]=genInitalRobotLocations(n,l,vis,sigma,epsilon)
%Init the graph structure
%Do while
while (true)
    %generate randome conditions     
    x0=round((l-1)*rand(n,2))+rand(n,2);
    
    %------------------------------------------------------------------
    % Verify initial connectivity to be above epsilon
    d=distt(x0');
    [L,Adj]=laplacian(x0,d,vis,sigma);
    
    % Algebraic Connectivity    
    [~,e]=eig(L);
    [ee,~]=sort(diag(e));
    lam2=ee(2);
    % We check the connectivity to be above twice epsilon (we are being 
    % conservative to handle discretization issues in the controller)
    if (lam2>2*epsilon) break; end
    % If we failed let's reduce the area in which the robots are deployed
    l=l*.9;
    
end
disp('connected!')
end

