%%%
clear all; close all; clc;
global xv yv xv1 yv1 node2;
%Add auxiliary functions
addpath('./functions');
addpath('./matgraph');
% load workspace;

video=1;
our=0;
conn_on=1; 
nSteps=400;  


if(video)
    writerObj = VideoWriter('out2.avi'); % Name it.
    writerObj.FrameRate = 20; % How many frames per second.
    open(writerObj);
end
% Variables
n=20;                          % Number of robots
l=10;                         % Side of the areas where the robots should be located in
                 % Number of steps
 dT=0.02;                      % Sampling time
vis_rate=.4;                  % Percentage of visibility w.r.t. the initial location area
vis=5;               % Visibility (% of the environment side)
sigma = 5;                    % Parameter for the regularity condition of the laplacian
epsilon = 0.5;                 % Lower bound for the algebraic connectivity

                   % Activate/Deactivate Connectivity Control Term
% xv=[4 4 7 7 4]';yv=[10 13 13 10 10]';
xv1=[10 15 20 15 10]';yv1=[15 10 15 20 15]';
flag1=0;
flag2=0;
node1=0;
node2=0;
virtual_node=zeros(n,2);
flag=zeros(n,1);

% Passino Parameters
a=3/10;
b=10;
c=2/10;




%Switch to plot the swarm behaviour in real time
real=1;                         % Plot real time
plot_scale=1;                   % Scale of the velocity vector

% Generate initial locations for the robots
[x0,~]=genInitalRobotLocations(n,l,vis,sigma,epsilon);

% % Drift to let the robots move cohesively in a direction
ue=5*.9*ones(n,2);
% p=(x(i,:)-[100 100]);
% velp=norm(p)^2;

%% Basic Data Structures
xH=zeros(nSteps,n,2);
bH=zeros(nSteps,2);
dH=zeros(nSteps,1);



%% Dynamics Simulation

% Initial Robot Locations
x=x0;

tic

if real==1
    fig=plot_real_time(x,i,1,l/plot_scale, vis);
%     fig=plot_direction(fig, x,i,1,l/plot_scale, zeros(n,2) , vis);
    drawnow
end
hold on
% plot(xv,yv,'b','linewidth',2);
plot(xv1,yv1,'b','linewidth',2);
% 
fill(xv1,yv1,'c');
h1=text(12,15,'Obstacle');
% h2=text(30,5,
xlabel('Obstacle Encirclement in Process');
hold off;
% frame = getframe(gcf); % 'gcf' can handle if you zoom in to take a movie.
% writeVideo(writerObj, frame);
% delete(h1);
for i=1:nSteps
    
    % Compute Laplacian
    d=distt(x');
%     d
    [L,Adj]=laplacian(x,d,vis,sigma);
    
    % Compute Algebraic Connectivity and related Eigenvector
    % Note that the computation is done in a centralized way for the sake
    % of simplicity
    [vv,e]=eig(L);
    [ee, idx]=sort(diag(e));
    lam2=ee(2);             % Second eigenvalue
    v2=vv(:,idx(2));        % Second eigenvector
    
%     disp('Current Algebraic Connectivity')
%     disp(lam2)

    %Swarm control input
    us = vel_passino(x,n,vis, a, b ,c);
    
    % Connectivity Maintenance
    if conn_on
        uc = conn(x,Adj,v2,lam2, sigma, epsilon);
    else
        uc = zeros(size(x));
    end
    
    [aa bb]=max(x);
    
    xx1=[aa(1)/2 aa(2)/2];
%     xx1
    up=zeros(n,2);
    for kk=1:n
        p=(-x(kk,:)+xx1);
        velp=norm(p);
        up(kk,:)=p*velp*.1;
    end

    tot_u=ue+us+uc+up;
    max_vel=5;
    for mm=1:n
       
       if(abs(tot_u(mm,2))>max_vel||abs(tot_u(mm,1))>max_vel)
            tot_u(mm,:)=tot_u(mm,:)/(max(abs(tot_u(mm,:)))/max_vel);
       end
    end
      
  
    % Compute next robots location (very simple integration)
    x=x+tot_u*dT;
    for ii=1:n
        if(inpolygon(x(ii,1),x(ii,2),xv1,yv1))
            if(~flag2)
                flag2=1;
                node2=ii;
            end
            flag(ii,1)=1;
            virtual_node(ii,:)=x(ii,:);
            x(ii,:)=x(ii,:)-tot_u(ii,:)*dT;
        else
            flag(ii,1)=0;
        end
        
    end
    % Store data
%     xH(i,:,:)=x;
%     bH(i,:)=mean(x);
%     dH(i,:)=sum(sum(triu(distt(x').^2)));
    
    if real==1
        update_plot_robot(fig,x,i,1,l/plot_scale, vis);%, lam2);
%         update_plot_direction(fig,x,i,1,l/plot_scale, tot_u , vis);
        drawnow
        if(video)
        frame = getframe(gcf); % 'gcf' can handle if you zoom in to take a movie.
        writeVideo(writerObj, frame);
        end
    end
    rrr=0;
%     if(length(find(flag==1))>0)
%         rrr=delaun_plot_robot(x,d, vis);
%        
%         pause(0.2);
%     end
%     if(rrr>=2)
%         break
%     end
end




if(our)

% save workspace;
d=distt(x');
% hold on
% plot(xv,yv,'b','linewidth',2);
% plot(xv1,yv1,'b','linewidth',2);
% for i=1:n
%     for j=i:n
%         if d(i,j)<vis
%             line([x(i,1) x(j,1)],[x(i,2) x(j,2)]);
%         end
%     end
% end
% rrr=delaun_plot_robot(x,d, vis);
% hold off;
% % Passino Parameters
 sigma=3;
%  epsilon = 0.6;                 % Lower bound for the algebraic connectivity
% a=2/10;
% b=10;
% c=2/10;
% 
xlabel('Obstacle Encirclement Complete');
if(video)
frame = getframe(gcf); % 'gcf' can handle if you zoom in to take a movie.
writeVideo(writerObj, frame);
end
% delete(h2);
% h3=text(30,5,'Hole Encirclement Complete \n Trying to move past the obstacle');
% h = msgbox(['Hole is detected '], 'Success');
for i=1:2000
    
    % Compute Laplacian
    
%     max_vel=5;
%     for mm=1:n
%        
%        if(abs(us(mm,2))>max_vel&&abs(us(mm,1))>max_vel)
%             us(mm,:)=us(mm,:)/(max(abs(us(mm,:)))/5);
%              %   us(mm,2)=sign(us(mm,2))*max_vel*(abs(us(mm,1))/(abs(us(mm,2))));
%     
%        elseif (abs(us(mm,1))>max_vel&&abs(us(mm,2))<=max_vel)
%                us(mm,:)=us(mm,:)/(max(abs(us(mm,:)))/5);
%                %us(mm,1)=sign(us(mm,1))*max_vel*(abs(us(mm,2))/(abs(us(mm,1))));
%        elseif (abs(us(mm,2))>max_vel&&abs(us(mm,1))<=max_vel)
%                us(mm,:)=us(mm,:)/(max(abs(us(mm,:)))/5);
%        else
%        end
%     end
%     x=x+us*dT;
%     for ii=1:n
% %         if(norm(x(ii,:)-[15 15])<2.5)
% %         if(inpolygon(x(ii,1),x(ii,2),xv,yv))
% %             if(~flag1)
% %                 flag1=0;
% %                 node1=ii;
% %             end
% %             flag(ii,1)=1;
% %             x(ii,:)=x(ii,:)-tot_u(ii,:)*dT;
% %         end
%         if(inpolygon(x(ii,1),x(ii,2),xv1,yv1))
% %             if(~flag2)
% %                 flag2=0;
% %                 node2=ii;
% %             end
%             virtual_node(ii,:)=x(ii,:);
%             flag(ii,1)=1;
%             x(ii,:)=x(ii,:)-us(ii,:)*dT;
%         else
%             flag(ii,1)=0;
%         end
%     end
    d=distt(x');
%     d
    [L,Adj]=laplacian(x,d,vis,sigma);
    
    % Compute Algebraic Connectivity and related Eigenvector
    % Note that the computation is done in a centralized way for the sake
    % of simplicity
    [vv,e]=eig(L);
    [ee, idx]=sort(diag(e));
    lam2=ee(2);             % Second eigenvalue
    v2=vv(:,idx(2));        % Second eigenvector
    us = vel_passino1(x,virtual_node,flag,n,vis, a, b ,c);
    disp('Current Algebraic Connectivity')
    disp(lam2)
%     p=(x(i,:)-[100 100]);
%     velp=norm(p);
%     ue=velp*.9*ones(n,2);
    %Swarm control input
    
    
    % Connectivity Maintenance
    if conn_on
        uc = conn(x,Adj,v2,lam2, sigma, epsilon);
    else
        uc = zeros(size(x));
    end
    
    [aa bb]=max(x);
    
    xx1=[aa(1)/2 aa(2)/2];
%     xx1
    up=zeros(n,2);
    if(our)
    for kk=1:n
        if(flag(kk,1)==0)
            p=(-x(kk,:)+xx1);
            velp=norm(p);
            up(kk,:)=p*velp*.01;
        end
    end
    end
%     for kk=1:n
%         if(flag(kk,1)==1)
%             count1=0;
%         for jj=1:n
%             
% %             if(kk~=jj&&d(kk,jj)<vis&&(~incheck(x(kk,:),x(jj,:),xv1,yv1)))
% %                 count1=1;
% %                 p=(-x(kk,:)+x(jj,:));
% %                 flag(kk,1)=0;
% %              
% %                 velp=norm(p);
% %                 up(jj,:)= up(jj,:)+p*velp*.5;
% %                 
% %             end
%             
%             x_T=(x(kk,:)+x(jj,:))/2;
%             if(kk~=jj&&d(kk,jj)<vis&&flag(jj,1)==0&&(~incheck(x(kk,:),x(jj,:),xv1,yv1))&&count1==0)
%                 count1=1;
%                 p=(-x(kk,:)+x(jj,:));
% %                 flag(kk,1)=0;
%              
%                 velp=norm(p);
%                 up(kk,:)=up(kk,:)+p*velp*.5;
%                 
%             end
%             if(kk~=jj&&d(kk,jj)<vis&&flag(jj,1)==1&&(~incheck(x(kk,:),x(jj,:),xv1,yv1)))
%                 p=(+x(kk,:)-x(jj,:));
% %                 flag(kk,1)=0;
%                 velp=norm(p);
%                 up(kk,:)=up(kk,:)+p*velp*.5;
%                 
%             end
%         end
%         end
%         if(d(kk,node2)<vis&&(~incheck(x(kk,:),x(node2,:),xv1,yv1)))
%         p=(-x(kk,:)+x(node2,:));
%         velp=norm(p)^2;
%         up(kk,:)=-p*(b*exp(-velp/c));
%         end
%     end
%    % xx2=x(bb(2),:);
%     xx1 
    %xx2
    % Complete Input (swarm+drift)
    tot_u=ue+us+uc+up;
%     tot_u(find(flag==1),:)
%     us(find(flag==1),:)
    
    max_vel=5;
    for mm=1:n
       
       if(abs(tot_u(mm,2))>max_vel||abs(tot_u(mm,1))>max_vel)
            tot_u(mm,:)=tot_u(mm,:)/(max(abs(tot_u(mm,:)))/5);
             %   us(mm,2)=sign(us(mm,2))*max_vel*(abs(us(mm,1))/(abs(us(mm,2))));
    
%        elseif (abs(us(mm,1))>max_vel&&abs(us(mm,2))<=max_vel)
%                us(mm,:)=us(mm,:)/(max(abs(us(mm,:)))/5);
%                %us(mm,1)=sign(us(mm,1))*max_vel*(abs(us(mm,2))/(abs(us(mm,1))));
%        elseif (abs(us(mm,2))>max_vel&&abs(us(mm,1))<=max_vel)
%                us(mm,:)=us(mm,:)/(max(abs(us(mm,:)))/5);
%        else
       end
    end
%     for mm=1:n
%        
%        if(abs(tot_u(mm,2))>max_vel)
%                 tot_u(mm,2)=sign(tot_u(mm,2))*max_vel*(abs(tot_u(mm,1))/(abs(tot_u(mm,2))));
%        end
%        if (abs(tot_u(mm,1))>max_vel)
%                tot_u(mm,1)=sign(tot_u(mm,1))*max_vel*(abs(tot_u(mm,2))/(abs(tot_u(mm,1))));
%        end
%        
%        
% %        if(flag(mm,1)==1)
% %            tot_u(mm,:)=[0,0];
% %        end
% %        if(flag2&&mm==node2)
% %            tot_u(mm,:)=[0,0];
% %        end
%     end
% %          tot_u  
%     ue
%     us
%     uc
    % Let us simulate the robot with id=1 has an engine fault starting from
    % time t=100. This allows to check whether the connectivity maintenance
    % does it job or not
%     if (i>100)
%         tot_u(1,:)=[0 0];
%     end
   % tot_u(1,:)=[0 0];
    % Compute next robots location (very simple integration)
    x=x+tot_u*dT;
    
    for ii=1:n
%         if(norm(x(ii,:)-[15 15])<2.5)
%         if(inpolygon(x(ii,1),x(ii,2),xv,yv))
%             if(~flag1)
%                 flag1=0;
%                 node1=ii;
%             end
%             flag(ii,1)=1;
%             x(ii,:)=x(ii,:)-tot_u(ii,:)*dT;
%         end
        if(inpolygon(x(ii,1),x(ii,2),xv1,yv1))
%             if(~flag2)
%                 flag2=0;
%                 node2=ii;
%             end
            virtual_node(ii,:)=x(ii,:);
            flag(ii,1)=1;
            x(ii,:)=x(ii,:)-tot_u(ii,:)*dT;
        else
            flag(ii,1)=0;
        end
    end
%     d=distt(x');
%     [roww,coll]=find(d<vis/1000);
%     for aa=1:length(roww)
%         if(roww~=coll)
%             x(roww,:)=x(roww,:)-tot_u(roww,:)*dT;
%             x(coll,:)=x(coll,:)-tot_u(coll,:)*dT;
%         end
%     end
    % Store data
%     xH(i,:,:)=x;
%     bH(i,:)=mean(x);
%     dH(i,:)=sum(sum(triu(distt(x').^2)));
    
    
    
    % Real Time Simulation plot
%     if real==1
%       %  fig=plot(x(:,1), x(:,2),'or');
%         axis([0 30 0 30]);
%        % update_plot_robot(fig,x,i,1,l/plot_scale, vis);
%         delaun_plot_robot(x,d, vis);
%         pause(0.2);
%         %, lam2);
%       %  update_plot_direction(fig,x,i,1,l/plot_scale, tot_u , vis);
% %         drawnow
%     end
    if real==1
        update_plot_robot(fig,x,i,1,l/plot_scale, vis);%, lam2);
%         update_plot_direction(fig,x,i,1,l/plot_scale, tot_u , vis);
        drawnow
        xlabel('Moving past the obstacle');
        if(video)
            frame = getframe(gcf); % 'gcf' can handle if you zoom in to take a movie.
            writeVideo(writerObj, frame);
        end
    
    end
%     rrr=delaun_plot_robot(x,d, vis);
%      pause(0.2);
%     if(rrr==3)
%         break
%     end
end
xlabel('Moved past the obstacle');
end
if(video)
    frame = getframe(gcf); % 'gcf' can handle if you zoom in to take a movie.
    writeVideo(writerObj, frame);
    close(writerObj);
end
% delete(h3);
% h4=text(30,5,'Hole Encirclement Complete \n Trying to move past the obstacle');
toc